unit CYBABOU3;

interface

uses windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,
  shellapi, sysutils;

type
  TCybAboutBox = class(TForm)
    Panel: TPanel;
    OKButton: TBitBtn;
    ProgramIcon: TImage;
    LblProductName: TLabel;
    LblVersion: TLabel;
    LblWrittenBy: TLabel;
    LblVoice: TLabel;
    LblFax: TLabel;
    LblEmail: TLabel;
    LblCompany: TLabel;
    LblOrigin: TLabel;
    LblPhoneSym: TLabel;
    LblMailSym: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    LblVerComment: TLabel;
    Label1: TLabel;
    procedure Label4DblClick(Sender: TObject);
    procedure LblEmailClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
    gap, icright : integer;
        fRegisterOrganisation : String;
        fRegisteredUserName : String;

    Procedure setlabel(lbl : tlabel; newval : string);
    Procedure setBoxcaptiontext(newval : string);
    Procedure setversiontext(newval : string);
    Procedure setvercommenttext(newval : string);
    Procedure setprodnametext(newval : string);
    Procedure setyeartext(newval : string);
    Procedure setbitmap(newval : tbitmap);
    procedure GetOSData;


  public
    { Public declarations }
    procedure setbmpsize ;
    procedure execute;
    Property Boxcaptiontext : string write setBoxcaptiontext;
    Property versiontext : string write setversiontext;
    Property vercommenttext : string write setvercommenttext;
    Property prodnametext : string write setprodnametext;
    Property yeartext : string write setyeartext;
    Property ICONBMP : tbitmap write setbitmap;

  end;


var
  CybAboutBox: TCybAboutBox;


implementation
uses
  registry,
  mapi;

{$R *.DFM}

procedure TCybAboutBox.execute;

begin
    if not(showing) then showmodal
                    else bringtofront;
    if modalresult = mrOK then hide;
end;

Procedure TCybAboutBox.setbitmap(newval : tbitmap);
begin
  if (newval <> nil) then begin
    ProgramIcon.picture.bitmap :=  newval;
    setbmpsize ;
  end
  else begin
    Icright := 0;
    gap := width;
  end;
end;

  procedure TCybAboutBox.setbmpsize ;
begin
    with ProgramIcon do Icright := left+width;
    gap := (panel.clientrect.right - Icright);
end;

Procedure TCybAboutBox.setBoxcaptiontext(newval : string);

begin
  caption := newval;
end;

Procedure TCybAboutBox.setlabel(lbl : tlabel; newval : string);

begin
  with Lbl do begin
    caption := newval;
    left := icright + ((gap - width) div 2);
  end;
end;

Procedure TCybAboutBox.setversiontext(newval : string);

begin
  setlabel( lblversion, newval);
{  lblversion.caption := newval;
  lblversion.left := 15;}
end;

Procedure TCybAboutBox.setvercommenttext(newval : string);

begin
{  setlabel( LblVerComment, newval);}
  LblVerComment.caption := newval;
  LblVerComment.left := 8;
  LblVerComment.top := 15;
  LblVerComment.width := GroupBox1.clientwidth - (2 * LblVerComment.left);
end;

Procedure TCybAboutBox.setprodnametext(newval : string);

begin
    setlabel(LblProductName ,newval);
end;

Procedure TCybAboutBox.setyeartext(newval : string);

begin
{  if (newval <> '') then with LblYear do caption := newval;}
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;


procedure TCybAboutBox.Label4DblClick(Sender: TObject);
begin
  executefile(Label4.caption, '', '', SW_SHOW);
end;


procedure TCybAboutBox.GetOSData;
var
  MyRegistry:Tregistry;
  tb : boolean;
  fOSID, astr : string;

begin
    myRegistry:=tregistry.create;
  try
    with myregistry do begin
       RootKey := HKEY_USERS;
       tb := OpenKey('\.DEFAULT\AppEvents\Schemes\Apps\.default\', False);
       if tb then begin
          fOSID := myregistry.ReadString('');
          RootKey :=HKEY_LOCAL_MACHINE;
          astr := '\SOFTWARE\Microsoft\'+fOSID+'\CurrentVersion\';
          tb := OpenKey(astr,False);
          if tb then begin
            fRegisteredUserName := myregistry.ReadString('RegisteredOwner');
            fRegisterOrganisation := myregistry.ReadString('RegisteredOrganization');
          end;
       end;
    end;
  finally
    myregistry.Free;
  end;
end;


procedure TCybAboutBox.LblEmailClick(Sender: TObject);
var
  MapiMessage : TMapiMessage;
  fMapiRecipDesc : PMapiRecipDesc;
  astr, bstr, cstr, dstr : string;

begin
  GetOSData;
  getmem(fMapiRecipDesc, sizeof(TMapiRecipDesc));
try
  fillchar(fMapiRecipDesc^, sizeof(TMapiRecipDesc), #0);
  fillchar(MapiMessage, sizeof(TMapiMessage), #0);
  with fMapiRecipDesc^ do begin
    astr := 'BORIS INGRAM'+#0;
    bstr := 'BORISING@IAFRICA.COM'+#0;
    lpszName := @bstr[1];
    lpszAddress := @astr[1];
    ulRecipClass:= MAPI_TO;
  end;
  with MapiMessage do begin
    nRecipCount := 1;
    lpRecips := fMapiRecipDesc;
    cstr := 'Re: Problem with '+LblProductName.caption+#0;
    lpszSubject := @cstr[1];
    dstr := fRegisteredUserName+' of '+fRegisterOrganisation+' encountered a problem with '+#13#10+LblProductName.caption+' at '
            +formatdatetime('dd/mm/yyyy HH:nn:ss', now)+'.'
            +#13#10+#13#10+'Details of what happened are : '
            +#13#10
            +#13#10
            +#0;
    lpszNoteText := @dstr[1];
  end;
  MapiSendMail(0,application.handle,MapiMessage,MAPI_SIMPLE_DEFAULT, 0);
finally
  freemem(fMapiRecipDesc, sizeof(TMapiRecipDesc));
  screen.cursor := crdefault;
  messagebeep(0);
end;
end;

procedure TCybAboutBox.FormActivate(Sender: TObject);
Var
   lc : integer;

begin
  lc := screen.pixelsperinch;
  scaleby(120, lc);
end;

{procedure TCybAboutBox.FormCreate(Sender: TObject);
begin
  Label1.caption := 'Cyborg Software';
  LblEmail.caption := 'borising@iafrica.com';
end;}

end.

